"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = __importDefault(require("child_process"));
var utils_1 = require("../utils");
var emitter_1 = require("./emitter");
var logger_1 = require("../logger");
var rimraf = require("rimraf");
var fs = require("fs");
var git = require("isomorphic-git");
git.plugins.set("fs", fs);
git.plugins.set("emitter", emitter_1.emitter);
var getTempSuffix = function (path) {
    var temp = Math.random()
        .toString(36)
        .substring(7);
    return path + "_temp_" + temp;
};
var GitManager = /** @class */ (function () {
    function GitManager(repo, cloneUrl) {
        this.repo = repo;
        this.cloneUrl = cloneUrl;
        this.clonePath = utils_1.toPath(utils_1.constructCloneUri(repo));
        this.finalPath = utils_1.toPath(utils_1.constructRootUri(repo));
    }
    GitManager.prototype.clone = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, utils_1.mkdir(this.clonePath)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, git.clone({
                                gitdir: this.clonePath,
                                url: this.cloneUrl,
                                noCheckout: true
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    GitManager.prototype.checkout = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger_1.log("Attempting to checkout at " + this.finalPath);
                        return [4 /*yield*/, utils_1.mkdir(this.finalPath)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, git.checkout({
                                gitdir: this.clonePath,
                                dir: this.finalPath,
                                ref: this.repo.sha
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    GitManager.prototype.cloneAndCheckout = function () {
        return __awaiter(this, void 0, void 0, function () {
            var isAvailable;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.isAlreadyCheckedOut()];
                    case 1:
                        isAvailable = _a.sent();
                        if (!!isAvailable) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.clone()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.checkout()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [2 /*return*/, fs.readdirSync(this.finalPath)];
                }
            });
        });
    };
    GitManager.prototype.isAlreadyCheckedOut = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        fs.readdir(_this.finalPath, function (err, files) {
                            resolve(files && files.length > 0);
                        });
                    })];
            });
        });
    };
    return GitManager;
}());
exports.GitManager = GitManager;
exports.info = function () { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve) {
                var cmd = "du -sh " + utils_1.toPath(utils_1.BASE_REPOS_URI);
                child_process_1.default.exec(cmd, function (error, stdout, stderr) {
                    resolve({
                        location: utils_1.BASE_REPOS_URI,
                        size: stdout,
                        repos: fs.readdirSync(utils_1.toPath(utils_1.BASE_REPOS_URI))
                    });
                });
            })];
    });
}); };
exports.removeAll = function () { return __awaiter(_this, void 0, void 0, function () {
    var _this = this;
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve, reject) {
                rimraf(utils_1.toPath(utils_1.BASE_REPOS_URI), function () { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, utils_1.mkdir(utils_1.toPath(utils_1.BASE_REPOS_URI))];
                            case 1:
                                _a.sent();
                                resolve();
                                return [2 /*return*/];
                        }
                    });
                }); });
            })];
    });
}); };
